package ve.gob.cnti.gestion.alfresco.impl;


import java.io.Serializable;
import java.util.Arrays;

import org.codehaus.jackson.annotate.JsonIgnore;

public class FileMessage implements Serializable{
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 5413789852539857776L;
	/**
	 * 
	 */
	
	public String uri;
	public String name;
	public byte[] fileUp;
	public String contenttype;
	public String identify;
	
	
	public FileMessage() {
		super();
	}
	public FileMessage(String uri, String name, byte[] fileUp, String contenttype) {
		super();
		this.uri = uri;
		this.name = name;
		this.fileUp = fileUp;
		this.contenttype = contenttype;
	}
	
	
	public FileMessage(String uri, String name, byte[] fileUp, String contenttype, String identify) {
		super();
		this.uri = uri;
		this.name = name;
		this.fileUp = fileUp;
		this.contenttype = contenttype;
		this.identify = identify;
	}
	@JsonIgnore
	public String getUri() {
		return uri;
	}
	@JsonIgnore
	public void setUri(String uri) {
		this.uri = uri;
	}
	@JsonIgnore
	public String getName() {
		return name;
	}
	@JsonIgnore
	public void setName(String name) {
		this.name = name;
	}
	@JsonIgnore
	public byte[] getFileUp() {
		return fileUp;
	}
	@JsonIgnore
	public void setFileUp(byte[] fileUp) {
		this.fileUp = fileUp;
	}
	@JsonIgnore
	public String getContenttype() {
		return contenttype;
	}
	@JsonIgnore
	public void setContenttype(String contenttype) {
		this.contenttype = contenttype;
	}
	@JsonIgnore
	public String getIdentify() {
		return identify;
	}
	@JsonIgnore
	public void setIdentify(String identify) {
		this.identify = identify;
	}
	@Override
	public String toString() {
		return "FileMessage [uri=" + uri + ", name=" + name + ", fileUp=" + Arrays.toString(fileUp) + ", contenttype="
				+ contenttype + ", identify=" + identify + "]";
	}
	
	
	
	
	

}
