package ve.gob.cnti.gestion.bonita.bean;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

public class User {
	private String last_connection;
	private String enabled;
	private String icon;
	private String manager_id;
	private String lastname;
	private String firstname;
	private String password;
	private String id;
	private String creation_date;
	private String created_by_user_id;
	private String title;
	private String job_title;
	private String userName;
	private String last_update_date;
	public User(String last_connection, String enabled, String icon,
			String manager_id, String lastname, String firstname,
			String password, String id, String creation_date,
			String created_by_user_id, String title, String job_title,
			String userName, String last_update_date) {
		super();
		this.last_connection = last_connection;
		this.enabled = enabled;
		this.icon = icon;
		this.manager_id = manager_id;
		this.lastname = lastname;
		this.firstname = firstname;
		this.password = password;
		this.id = id;
		this.creation_date = creation_date;
		this.created_by_user_id = created_by_user_id;
		this.title = title;
		this.job_title = job_title;
		this.userName = userName;
		this.last_update_date = last_update_date;
	}
	
	public User(){}

	
	public User castToUserObj(Map<String,String> map){
		
		String[] valores = new String[map.size()];
		
		int i = 0;
		for(String val: map.values()){
			valores[i]=val;
			i++;
		}
	
		User user = new User(valores[0],valores[1],valores[2],valores[3],valores[4],valores[5],valores[6],valores[7],valores[8],valores[9],valores[10],valores[11],valores[12],valores[13]);
		
		return user;
	}
	
	
	public List<User>  castToListUserObj(List<Map<String,String>>  list){
		
		Iterator<Map<String,String>>  it = list.iterator();
		List<User> listObjets = new ArrayList<User>();
		
		while(it.hasNext()){
			 
			Map<String,String> map = new HashMap<String, String>();
			map = it.next();
			listObjets.add(this.castToUserObj(map));
			
		}
		
		return listObjets;
	}
	
	
	public String getLast_connection() {
		return last_connection;
	}

	public void setLast_connection(String last_connection) {
		this.last_connection = last_connection;
	}

	public String getEnabled() {
		return enabled;
	}

	public void setEnabled(String enabled) {
		this.enabled = enabled;
	}

	public String getIcon() {
		return icon;
	}

	public void setIcon(String icon) {
		this.icon = icon;
	}

	public String getManager_id() {
		return manager_id;
	}

	public void setManager_id(String manager_id) {
		this.manager_id = manager_id;
	}

	public String getLastname() {
		return lastname;
	}

	public void setLastname(String lastname) {
		this.lastname = lastname;
	}

	public String getFirstname() {
		return firstname;
	}

	public void setFirstname(String firstname) {
		this.firstname = firstname;
	}

	public String getPassword() {
		return password;
	}

	public void setPassword(String password) {
		this.password = password;
	}

	public String getId() {
		return id;
	}

	public void setId(String id) {
		this.id = id;
	}

	public String getCreation_date() {
		return creation_date;
	}

	public void setCreation_date(String creation_date) {
		this.creation_date = creation_date;
	}

	public String getCreated_by_user_id() {
		return created_by_user_id;
	}

	public void setCreated_by_user_id(String created_by_user_id) {
		this.created_by_user_id = created_by_user_id;
	}

	public String getTitle() {
		return title;
	}

	public void setTitle(String title) {
		this.title = title;
	}

	public String getJob_title() {
		return job_title;
	}

	public void setJob_title(String job_title) {
		this.job_title = job_title;
	}

	public String getUserName() {
		return userName;
	}

	public void setUserName(String userName) {
		this.userName = userName;
	}

	public String getLast_update_date() {
		return last_update_date;
	}

	public void setLast_update_date(String last_update_date) {
		this.last_update_date = last_update_date;
	}

	@Override
	public String toString() {
		return "User [last_connection=" + last_connection + ", enabled="
				+ enabled + ", icon=" + icon + ", manager_id=" + manager_id
				+ ", lastname=" + lastname + ", firstname=" + firstname
				+ ", password=" + password + ", id=" + id + ", creation_date="
				+ creation_date + ", created_by_user_id=" + created_by_user_id
				+ ", title=" + title + ", job_title=" + job_title
				+ ", userName=" + userName + ", last_update_date="
				+ last_update_date + "]";
	}
	
}
