package ve.gob.cnti.gestion.controller;

import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.util.ArrayList;
import java.util.List;
import java.util.regex.Pattern;

import javax.faces.bean.ManagedBean;
import javax.faces.bean.RequestScoped;

import org.bonitasoft.engine.api.IdentityAPI;
import org.bonitasoft.engine.api.ProcessAPI;
import org.bonitasoft.engine.bpm.flownode.HumanTaskInstance;
import org.bonitasoft.engine.bpm.flownode.HumanTaskInstanceSearchDescriptor;
import org.bonitasoft.engine.exception.AlreadyExistsException;
import org.bonitasoft.engine.exception.CreationException;
import org.bonitasoft.engine.exception.SearchException;
import org.bonitasoft.engine.exception.UpdateException;
//import org.bonitasoft.engine.identity.User;
import org.bonitasoft.engine.identity.UserNotFoundException;
import org.bonitasoft.engine.identity.UserUpdater;
import org.bonitasoft.engine.platform.LoginException;
import org.bonitasoft.engine.search.SearchOptionsBuilder;
import org.bonitasoft.engine.search.SearchResult;
import org.bonitasoft.engine.session.APISession;
import org.json.JSONException;

import ve.gob.cnti.gestion.bonita.ITask;
import ve.gob.cnti.gestion.bonita.IUser;
import ve.gob.cnti.gestion.bonita.bean.Task;
import ve.gob.cnti.gestion.bonita.bean.User;
import ve.gob.cnti.gestion.bonitaImpl.SessionImpl;
import ve.gob.cnti.gestion.bonitaImpl.TaskImpl;
import ve.gob.cnti.gestion.bonitaImpl.UserImpl;
import ve.gob.cnti.gestion.utils.FacesHandler;

@ManagedBean(name = "testController", eager = true)
@RequestScoped
public class TestController {
	//268 linea
	public String test(){
		//code
		//#########################PRUEBAS DE LOGUEO##########################
//		SessionImpl sessionImpl = new SessionImpl();
//		APISession apiSession = null;
//		FacesHandler facehandler = new FacesHandler();
//		try {
//			apiSession = sessionImpl.startEngineConection("rrhh", "QL0AFWMIX8NRZTKeof9cXsvbvu8=GATO");
//			//apiSession = sessionImpl.startEngineConection(facehandler.getUserSession().get("user"), facehandler.getUserSession().get("pass"));
//		} catch (LoginException e) {
//			e.printStackTrace();
//		}
		//#########################PRUEBAS USUARIO NO ENCONTRADO##########################
//		APISession apiSession = null;
//		FacesHandler facehandler = new FacesHandler();
//		SessionImpl sessionImpl = new SessionImpl();
//		org.bonitasoft.engine.identity.User u = null;
//		try {
//			//apiSession = sessionImpl.startEngineConection(facehandler.getUserSession().get("user"), facehandler.getUserSession().get("pass"));
//			apiSession = sessionImpl.startEngineConection("rrhh", "QL0AFWMIX8NRZTKeof9cXsvbvu8=GATO");
//			IdentityAPI identityAPI = SessionImpl.getIdentityAPI(apiSession);
//			u = identityAPI.getUserByUserName("rrhh");
//		} catch (LoginException e) {
//			e.printStackTrace();
//		} catch (UserNotFoundException e) {
//			System.out.println("UserNotFoundException: USUARIO NO ES ENCONTRADO");
//			//e.printStackTrace();
//		}
		//#########################PRUEBAS DE USUARIO EXISTENTE EN LA CREACION##########################
		
//		org.bonitasoft.engine.identity.User u = null;
//		SessionImpl sessionImpl = new SessionImpl();
//		APISession apiSession = null;
//		String idUser = null;
//		System.out.println("########################INTENTANDO CREAR EL USUARIO#####################################");
//		
//		try {
//			apiSession = sessionImpl.startEngineConection("admin", "admin");
//			IdentityAPI identityAPI = SessionImpl.getIdentityAPI(apiSession);
//			u = identityAPI.createUser("gato", "aristogato");
//			idUser = Long.toString(u.getId());
//			//addMembershipToUser(idUser);
//			
//		} catch (AlreadyExistsException e) {
//			// TODO Auto-generated catch block
//			//e.printStackTrace();
//			System.out.println("#######################################USUARIO EXISTENTE DETECTADO######################################");
//			//updateUserPassword(username, password);
//		} catch (CreationException e) {
//			// TODO Auto-generated catch block
//			e.printStackTrace();
//		} catch (LoginException e) {
//			// TODO Auto-generated catch block
//			e.printStackTrace();
//		}
//		sessionImpl.stopEngineConection(apiSession);
//		//return idUser;
		
		//#########################PRUEBAS ACTUALIZACION DE PASSWORD##########################
		
//		SessionImpl sessionImpl = new SessionImpl();
//		UserUpdater uu = new UserUpdater();
//		APISession apiSession = null;
//		System.out.println("#####################################INTENTANDO ACTUALIZAR EL PASSWORD################################");
//		try {
//			apiSession = sessionImpl.startEngineConection("admin", "admin");
//			IdentityAPI identityAPI = SessionImpl.getIdentityAPI(apiSession);
//			//Long idUser = Long.parseLong(getIdByuserName("gato"));
//			//System.out.println("USUARIO A ACTUALIZAR: ID-> " + idUser);
//			identityAPI.updateUser(301L, uu.setPassword("guarapo2"));
//		} catch (LoginException e) {
//			// TODO Auto-generated catch block
//			e.printStackTrace();
//		} catch (UserNotFoundException e) {
//			// TODO Auto-generated catch block
//			e.printStackTrace();
//		} catch (UpdateException e) {
//			// TODO Auto-generated catch block
//			e.printStackTrace();
//		}
//		sessionImpl.stopEngineConection(apiSession);
		
		//#########################PRUEBAS DE CONSULTAR LISTA DE POSIBLES EJECUTORES PARA UNA TAREA##########################
//		SessionImpl sessionImpl = new SessionImpl();
//		APISession apiSession = null;
//		FacesHandler facehandler = new FacesHandler();
//		List<User> listaUsuarios = new ArrayList<User>();
//		
//		try {
//			apiSession = sessionImpl.startEngineConection(facehandler.getUserSession().get("user"), facehandler.getUserSession().get("pass"));
//			ProcessAPI processAPI = sessionImpl.getProcessAPI(apiSession);
//			listaUsuarios = processAPI.getPossibleUsersOfPendingHumanTask(840002L, 0, 100);
//			
//			for (User user : listaUsuarios) {
//				System.out.println(user.getUserName());
//			}
//			
//		} catch (LoginException e) {
//			// TODO Auto-generated catch block
//			e.printStackTrace();
//		}
//		sessionImpl.stopEngineConection(apiSession);
		//#############################################################################################################################
		

		SessionImpl sessionImpl = new SessionImpl();
		APISession apiSession = null;
		FacesHandler facehandler = new FacesHandler();
		List<User> listaUsuarios = new ArrayList<User>();
		IUser user = new UserImpl();
		
		//try {
			//apiSession = sessionImpl.startEngineConection(facehandler.getUserSession().get("user"), facehandler.getUserSession().get("pass"));
			//ProcessAPI processAPI = sessionImpl.getProcessAPI(apiSession);
			//listaUsuarios = processAPI.getPossibleUsersOfPendingHumanTask(840002L, 0, 100);
			
//			for (User user : listaUsuarios) {
//				System.out.println(user.getUserName());
//			}
			
			//listaUsuarios = user.gesUsersAvailablesForTask("840002");
			//System.out.println(listaUsuarios.toString());
//			for (User user2 : listaUsuarios) {
//				System.out.println(user2.getUserName());
//			}
			
		//} catch (LoginException e) {
			// TODO Auto-generated catch block
		//	e.printStackTrace();
		//}
		//sessionImpl.stopEngineConection(apiSession);

		
		//##########################################EJEMPLO DE OBTENER TAREAS DE ASIGNACION#############################################
//			
//			System.out.println("---OBTENER TAREAS DE ASIGNACION---");
//			String idUser = "104";
//			List<Task> availableTasks = new ArrayList<Task>();
//			try {
//				//apiSession = sessionImpl.startEngineConection(facehandler
//				//		.getUserSession().get("user"), facehandler.getUserSession()
//				//		.get("pass"));
//				apiSession = sessionImpl.startEngineConection("admin","admin");
//				ProcessAPI processAPI = sessionImpl.getProcessAPI(apiSession);
//				SearchOptionsBuilder builder = new SearchOptionsBuilder(0, 100);	
//				//builder.filter(HumanTaskInstanceSearchDescriptor.NAME,"^_ASSIGNMENT_.*");
//								
//				SearchResult<HumanTaskInstance> humanTaskInstanceResults = processAPI
//						.searchMyAvailableHumanTasks(Long.parseLong(idUser, 10),
//								builder.done());
//				System.out.println(humanTaskInstanceResults.getCount());
//				for (HumanTaskInstance humanTaskInstance : humanTaskInstanceResults
//						.getResult()) {
//					if (humanTaskInstance.getName().matches("^_ASIG_.*")) {
//						System.out.println(humanTaskInstance.getName());
//						availableTasks.add(beanTask2stringBeanTask(humanTaskInstance));
//						
//					}
//					
//				}
//			} catch (LoginException e1) {
//				// TODO Auto-generated catch block
//				e1.printStackTrace();
//			} catch (NumberFormatException e) {
//				// TODO Auto-generated catch block
//				e.printStackTrace();
//			} catch (SearchException e) {
//				// TODO Auto-generated catch block
//				e.printStackTrace();
//			}
//			sessionImpl.stopEngineConection(apiSession);
//			
//			//return availableTasks;
//
//			
//			
//		
//		return "/views/view.xhtml";
//	}
//	
//	
//	private Task beanTask2stringBeanTask(HumanTaskInstance hti) {
//		Task t = new Task(hti.getDisplayDescription(), 
//				Long.toString(hti.getProcessDefinitionId()), 
//				hti.getState(), 
//				hti.getType().toString(), 
//				Long.toString(hti.getAssigneeId()), 
//				hti.getReachedStateDate().toString(), 
//				Long.toString(hti.getId()),
//				Long.toString(hti.getExecutedBy()), 
//				Long.toString(hti.getParentContainerId()), 
//				hti.getPriority().toString(),
//				hti.getDescription(), 
//				Long.toString(hti.getActorId()),
//				hti.getName(), 
//				hti.getReachedStateDate().toString(),
//				hti.getDisplayName(), 
//				hti.getExpectedEndDate().toString(), 
//				hti.getLastUpdateDate().toString()
//				);
//		return t;
	//#############################################OBTENER TAREA HIJA##########################################
			ITask task = new TaskImpl();
			
			
			Task dependingTask = new Task();
			//APISession apiSession = null;
			
			try {
				Task masterTask = task.getTask("860006");
				apiSession = sessionImpl.startEngineConection(facehandler.getUserSession().get("user"), facehandler.getUserSession().get("pass"));
				ProcessAPI processAPI = sessionImpl.getProcessAPI(apiSession);
				SearchOptionsBuilder builder = new SearchOptionsBuilder(0, 100);
				builder.filter(HumanTaskInstanceSearchDescriptor.PROCESS_INSTANCE_ID,masterTask.getCaseId());
				// TODO: Suprimir este sleep, se coloco mientras se realiza la migraciÃ³n
				// del resto de los metodos de acces a Bonita
				Thread.sleep(3000);
				SearchResult<HumanTaskInstance> humanTaskInstanceResults = processAPI
						.searchHumanTaskInstances(builder.done());
				for (HumanTaskInstance hti : humanTaskInstanceResults.getResult()) {
					
					if (masterTask.getName().matches("_ASIG_TRUE_"+hti.getName()) || masterTask.getName().matches("_ASIG_FALSE_"+hti.getName())){
						//masterTask.getName().matches("_ASIG_TRUE"+hti.getName())
						dependingTask = beanTask2stringBeanTask(hti);
						
						//listado de usuario de obtiene del metodo gesUsersAvailablesForTask de la interfaz IUser para llenar la variable idUser
//						task.assignTask(idUser, dependingTask.getId());
						
						//para ejecutar la tarea de utiliza el metodo executeTask de la interfaz ITask
						task.executeTask(masterTask.getId());
						
						
						System.out.println(dependingTask.toString());
					}
					
				}

			} catch (SearchException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (LoginException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (UnsupportedEncodingException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (IllegalStateException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (JSONException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			
			sessionImpl.stopEngineConection(apiSession);
			
			return null;
	}
	
	private Task beanTask2stringBeanTask(HumanTaskInstance hti) {
		Task t = new Task(hti.getDisplayDescription(), 
				Long.toString(hti.getProcessDefinitionId()), 
				hti.getState(), 
				hti.getType().toString(), 
				Long.toString(hti.getAssigneeId()), 
				hti.getReachedStateDate().toString(), 
				Long.toString(hti.getId()),
				Long.toString(hti.getExecutedBy()), 
				Long.toString(hti.getParentContainerId()), 
				hti.getPriority().toString(),
				hti.getDescription(), 
				Long.toString(hti.getActorId()),
				hti.getName(), 
				hti.getReachedStateDate().toString(),
				hti.getDisplayName(), 
				hti.getExpectedEndDate().toString(), 
				hti.getLastUpdateDate().toString()
				);
		return t;

	}
	

}
