package ve.gob.cnti.gestion.controller.beanFiles;

import java.util.ArrayList;
import java.util.List;

/**Clase bean que sirve para el manejo de los archivos con su nivel de detalle.
 * 
 * @author Joaquin Pereira
 */
public class BeanFile {

	private String varName;
	private String nombreOficial;
	private List<String> fileNames = new ArrayList<String>();	
	private boolean obligatorio;
	private boolean multiple;
	private long pesoDelArchivo;
	private int totalDeArchivos;
	private String tab;

	public boolean isObligatorio() {
		return obligatorio;
	}

	public void setObligatorio(boolean obligatorio) {
		this.obligatorio = obligatorio;
	}

	public boolean isMultiple() {
		return multiple;
	}

	public void setMultiple(boolean multiple) {
		this.multiple = multiple;
	}

	public String getVarName() {
		return varName;
	}

	public void setVarName(String varName) {
		this.varName = varName;
	}

	public long getPesoDelArchivo() {
		return pesoDelArchivo;
	}

	public void setPesoDelArchivo(long pesoDelArchivo) {
		this.pesoDelArchivo = pesoDelArchivo;
	}

	public int getTotalDeArchivos() {
		return totalDeArchivos;
	}

	public void setTotalDeArchivos(int totalDeArchivos) {
		this.totalDeArchivos = totalDeArchivos;
	}

	public String getNombreOficial() {
		return nombreOficial;
	}

	public void setNombreOficial(String nombreOficial) {
		this.nombreOficial = nombreOficial;
	}

	public List<String> getFileNames() {
		return fileNames;
	}

	public void setFileNames(List<String> fileNames) {
		this.fileNames = fileNames;
	}

	public String getTab() {
		return tab;
	}

	public void setTab(String tab) {
		this.tab = tab;
	}

	@Override
	public String toString() {
		return "FormTestFilesBeans [varName=" + varName + ", nombreOficial="
				+ nombreOficial + ", fileNames=" + fileNames + ", obligatorio="
				+ obligatorio + ", multiple=" + multiple + ", pesoDelArchivo="
				+ pesoDelArchivo + ", totalDeArchivos=" + totalDeArchivos
				+ ", tab=" + tab + "]";
	}
	
}
