package ve.gob.cnti.gestion.formfile;

import java.io.File;
import java.io.IOException;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.SessionScoped;

import org.apache.commons.io.FileUtils;
import org.primefaces.model.UploadedFile;
@ManagedBean(name = "fileManager", eager = true)
@SessionScoped
public class FileManager {
	
	
	public String path;
	public File file;
	
	public FileManager(String path){
		this.path=path;
	}
	
	
	public void addFile(UploadedFile uFile){
		
		file= new File(path);
     	try {
		FileUtils.copyInputStreamToFile(uFile.getInputstream(), file);
			
		} catch (IOException e) {				
			e.printStackTrace();
		}	
       
	}
	
	
	public File findFile(){
		file=new File(this.path);
		return file;
	}
	
	public boolean fileExists(){
		return this.file.exists();
	}
	
	public void remove(){
		file=new File(this.path);
		file.delete();
		
	}
	
	

}
