package ve.gob.cnti.gestion.formfile;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

import javax.faces.bean.ManagedBean;
import javax.faces.bean.SessionScoped;
@ManagedBean(name = "folderManager", eager = true)
@SessionScoped
public class FolderManager {
	
	private String path="";
	
	
	public FolderManager(String caseId){
		
		this.path=System.getProperty("java.io.tmpdir")+"/"+caseId;
		
	}
	
	public void createDir(){
		
		File file = new File(path);
		if (!file.exists()) {
			if (file.mkdir()) {
				System.out.println("Directory is created!");				
			
			}
		} else {
			 File[] ficheros = file.listFiles();	
			 System.out.println("Deleting files");
			 for (int x=0;x<ficheros.length;x++){					 
				 ficheros[x].delete();					 
			 }				 
			
		}
		
	}
		
	public List<String> listFile(){
		 File file = new File(this.path);
		 File[] ficheros = file.listFiles();
		 List<String> files=new ArrayList<String>();
		 for (int x=0;x<ficheros.length;x++){
			 files.add(ficheros[x].getName());					 
		 }
		return files;
	}
	
	
	public FileManager getFileManager(String name){
		FileManager fileManager=new FileManager(path+"/"+name);
		return fileManager;
	}
	
	
	
	public void deleteFolder(){
		 File file = new File(path);
		 File[] ficheros = file.listFiles();	
		 if(ficheros!=null){
			 for (int x=0;x<ficheros.length;x++){					 
				 ficheros[x].delete();					 
			 }
		 }
		 file.delete();
	}

	public String getPath() {
		return path;
	}

	public void setPath(String path) {
		this.path = path;
	}
	
}
