package ve.gob.cnti.gestion.utils;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Vector;
import com.eclipsesource.json.JsonArray;
import com.eclipsesource.json.JsonObject;

public class JsonParser {


	/**
	 * 
	 * @param Json Es el string de array json a ser parseado
	 * @param pathFileProperties El path de la paqueteria donde se encuentra el archivo properties que define los elementos del array json
	 *  
	 * @return <strong>List String[]</strong> Lista de string con los valores del array parseados.
	 */	
	public List<Map<String,String>> parsearArrayJson(String Json, String pathFileProperties){		
		
		JsonArray json = JsonArray.readFrom(Json);
		PropertiesReader pr = new PropertiesReader();
		
		List<Map<String,String>> listValues = new ArrayList<Map<String,String>>();
		
		Vector<String> keysContainer = pr.propertiesGetKeys(pathFileProperties);				
		Map<String,String> map;
		
		for (int i = 0; i < json.size(); i++) {	
			
			map = new HashMap<String,String>();
			
		    JsonObject show = json.get(i).asObject();  
		    
		    for(int j=0;j<show.size();j++){
		    	
		    	map.put(keysContainer.get(j), show.get(keysContainer.get(j).toString()).asString());

		    }		    
		    listValues.add(map);		    
		}		
		return listValues;		
	}

}
