package ve.gob.cnti.gestion.utils;

import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;

public class Util_Dates {
	
	private Calendar f = new GregorianCalendar();
	
	public int calcularEdad(Date date) {
		
		Calendar fechaNac =  DateToCalendar(date);
		
	    Calendar fechaActual = Calendar.getInstance();
	 
	    int anios = fechaActual.get(Calendar.YEAR) - fechaNac.get(Calendar.YEAR);
	    int meses = fechaActual.get(Calendar.MONTH) - fechaNac.get(Calendar.MONTH);
	    int dias = fechaActual.get(Calendar.DAY_OF_MONTH) - fechaNac.get(Calendar.DAY_OF_MONTH);
	 
	    if(meses < 0 || (meses==0 && dias < 0)) { 
	        anios--;
	    }
	    return anios;
	}
	
	public Calendar DateToCalendar(Date date){ 
	  Calendar cal = Calendar.getInstance();
	  cal.setTime(date);
	  return cal;
	}
	
	public String getDate(){
		return f.get(Calendar.DAY_OF_MONTH)+"/"+(f.get(Calendar.MONTH)+1)+"/"+f.get(Calendar.YEAR);
	}
	
	public String getHour(){		
		return f.get(Calendar.HOUR_OF_DAY)+":"+f.get(Calendar.MINUTE)+":"+f.get(Calendar.SECOND);
	}

}
