package ve.gob.cnti.gestion.utils.validators;

import javax.faces.application.FacesMessage;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.SessionScoped;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.validator.FacesValidator;
import javax.faces.validator.Validator;
import javax.faces.validator.ValidatorException;

import ve.gob.cnti.gestion.utils.PropertiesReader;

@FacesValidator("ConfirmPassValidator")
public class ConfirmPassValidator implements Validator {

	@Override
	public void validate(FacesContext context, UIComponent component, Object value) throws ValidatorException {

        String password = (String) component.getAttributes().get("newPassword");
		String confirm = (String) value;        
		
		//System.out.println(password);
		//System.out.println(confirm);
        
//        if (password == null || confirm == null) {
//            return; 
//        }
        
        if (!password.equals(confirm)) {
        	FacesMessage msg = new FacesMessage(new PropertiesReader()
					.getI18nProperty("mjsConfirmPassValidatorFail")); 
        	msg.setSeverity(FacesMessage.SEVERITY_ERROR);
        	throw new ValidatorException(msg);
        	
        }
	}
	
}
