package ve.gob.cnti.gestion.utils.validators;

import java.util.Date;
import java.util.Iterator;

import javax.faces.application.FacesMessage;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.validator.FacesValidator;
import javax.faces.validator.Validator;
import javax.faces.validator.ValidatorException;

import org.primefaces.component.calendar.Calendar;

/**
 * Validador para calcular si una persona puede a optar a la jubilación por edad avanzada
 * de acuerdo a su edad y sexo.
 * 
 * @author Joaquin Pereira
 */
@FacesValidator("searchDatesRangeConsultHistory")
public class searchDatesRange implements Validator{

	@Override
	public void validate(FacesContext context, UIComponent component,
			Object value) throws ValidatorException {
		
		FacesMessage msg = null;
		
		/**TODO
		 * 
		 * VERIFICAR QUE ESTEN LAS DOS FECHAS
		 * VERFICAR QUE LA FECHA DE MODIFICACION SEA MAYOR O IGUAL A LA FECHA DE SOLICITUD
		 * 
		 */
		
		System.out.println(component.getId().toString()+" --- ID ");
		if(value != null){
			
			if(component.getId().contentEquals("d_fechaSolicitud")){
				try {
					
					Calendar a_fecha = (Calendar) component.getAttributes().get("b_fechaModificacion");
					if(a_fecha.getValue().toString()!=null){
						Date fechaFin = (Date) a_fecha.getValue();
						System.out.println("try");
						System.out.println("fecha ==> "+fechaFin.toString());
					}					
				} catch (Exception e) {
					// TODO: handle exception
					System.out.println("1 np pudo obtener nada");
					msg = new FacesMessage("Error", "Debe indicar la fecha de la última modificación");
					msg.setSeverity(FacesMessage.SEVERITY_ERROR);
				}
			}else if(component.getId().contentEquals("fechaModificacion")){
				try {
					Calendar b_fecha = (Calendar) component.getAttributes().get("b_fechaSolicitud");
					if(b_fecha.getValue().toString()!=null){
						Date fechaini = (Date) b_fecha.getValue();
						System.out.println("try");
						System.out.println("fecha ==> "+fechaini.toString());
					}
				} catch (Exception e) {
					// TODO: handle exception
					System.out.println("2 np pudo obtener nada");
					msg = new FacesMessage("Error", "Debe indicar la fecha de la solicitud");
					msg.setSeverity(FacesMessage.SEVERITY_ERROR);
				}
			}
			
		}
			
		System.out.println();
		if(msg!=null)
			throw new ValidatorException(msg);
		
	}
}
