# Proyecto para la automatización de trámites 

Es una solución integral para automatizar trámites,
y colocarlos a disposición de los ciudadanos y ciudadanas

* Descargue el manual oficial de instalación: [Manual de Instalación](http://desarrollo.softwarepublico.gob.ve/tramites/01-bandeja-tramites-web/raw/master/Manual-Instalacion-Maquina-Tramite.odt)

## Usando las Bandejas

Se compone de dos bandejas ``bandeja-ciudadano`` y 
 ``bandeja-funcionario``, están escrito en código java, por 
lo que es necesario parametrizar el código de acuerdo al trámite
a automarizar.

Se genera un archivo  ``.war`` el cual se despliega dentro del
servidor Tomcat de la solución de automatización de trámites.

## Componentes para la implementación

* Parseador: http://desarrollo.softwarepublico.gob.ve/tramites/02-parserMVC-bootsfaces
* Repositorio: http://desarrollo.softwarepublico.gob.ve/tramites/05-repositorio
* Sistema de Gestión Interna: http://desarrollo.softwarepublico.gob.ve/tramites/04-gestioninterna
* Mensajería: [EARCiudadano] (http://desarrollo.softwarepublico.gob.ve/tramites/03.0-Mensajeria-EARCiudadano) [CiudadanoJMS] (http://desarrollo.softwarepublico.gob.ve/tramites/03.1-Mensjaeria-CiudadanoJMS) [EARReceiver] (http://desarrollo.softwarepublico.gob.ve/tramites/03.2-Mensajeria-EARReceiver) [ReceiverJMS] (http://desarrollo.softwarepublico.gob.ve/tramites/03.3-Mensajeria-ReceiverJMS) 

## Documentación

Revise la wiki para la información de la implementación.

[Wiki] (http://desarrollo.softwarepublico.gob.ve/tramites/01-bandeja-tramites-web/wikis/home>)

O descargue el manual oficial:

[Manual de Instalación] (http://desarrollo.softwarepublico.gob.ve/tramites/01-bandeja-tramites-web/raw/master/Manual-Instalacion-Maquina-Tramite.odt)
