
package ve.gob.cnti.gestion.alfresco.impl;

import java.io.InputStream;
import java.math.BigInteger;

public class ContentStream {
	
	private BigInteger bigLength;
	private String fileName;
	private long length;
	private String mimeType;
	private InputStream stream;
	
	
	public ContentStream(){
		super();		
	}
	
	public ContentStream(String fileName, InputStream stream, String mimeType, long length, BigInteger bigLength) {
		super();
		this.bigLength = bigLength;
		this.fileName = fileName;
		this.length = length;
		this.mimeType = mimeType;
		this.stream = stream;
	}
	public BigInteger getBigLength() {
		return bigLength;
	}
	public void setBigLength(BigInteger bigLength) {
		this.bigLength = bigLength;
	}
	public String getFileName() {
		return fileName;
	}
	public void setFileName(String fileName) {
		this.fileName = fileName;
	}
	public long getLength() {
		return length;
	}
	public void setLength(long length) {
		this.length = length;
	}
	public String getMimeType() {
		return mimeType;
	}
	public void setMimeType(String mimeType) {
		this.mimeType = mimeType;
	}
	public InputStream getStream() {
		return stream;
	}
	public void setStream(InputStream stream) {
		this.stream = stream;
	}
	

}
