package ve.gob.cnti.gestion.user;

import java.io.Serializable;

public class User {

	 private static final long serialVersionUID = 1L;

	    private String userId;
	    private String firstName;
	    private String lastName;
	    private String role;
	    private String email;

	    public User(String userId, String firstName, String lastName, String role, String email) {
	        super();

	        this.userId = userId;
	        this.firstName = firstName;
	        this.lastName = lastName;
	        this.role = role;
	        this.email = email;
	    }

	    public String getUserId() {
	        return userId;
	    }

	    public void setUserId(String userId) {
	        this.userId = userId;
	    }

	    public String getFirstName() {
	        return firstName;
	    }

	    public void setFirstName(String firstName) {
	        this.firstName = firstName;
	    }

	    public String getLastName() {
	        return lastName;
	    }

	    public void setLastName(String lastName) {
	        this.lastName = lastName;
	    }

	    public String getName() {
	        return firstName + " " + lastName;
	    }

	    public String getRole() {
			return role;
		}

		public void setRole(String role) {
			this.role = role;
		}

		public String getEmail() {
			return email;
		}

		public void setEmail(String email) {
			this.email = email;
		}

		@Override
		public String toString() {
			return "User [userId=" + userId + ", firstName=" + firstName + ", lastName=" + lastName + ", role=" + role
					+ ", email=" + email + "]";
		}	
		

}
