package ve.gob.cnti.gestion.utils.validators;

import javax.faces.application.FacesMessage;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.validator.FacesValidator;
import javax.faces.validator.Validator;
import javax.faces.validator.ValidatorException;

import ve.gob.cnti.gestion.utils.PropertiesReader;

@FacesValidator("IntegerValidator")
public class IntegerValidator implements Validator {

	@Override
	public void validate(FacesContext context, UIComponent component,
			Object value) throws ValidatorException {
		if (!(value instanceof Integer)) {
			FacesMessage msg = new FacesMessage("", new PropertiesReader()
			.getI18nProperty("mjsIntegerValidator"));
			msg.setSeverity(FacesMessage.SEVERITY_ERROR);
			throw new ValidatorException(msg);
		}
	}

}
